#ifndef CHIP_CLK_CONSTRAINTS_H
#define CHIP_CLK_CONSTRAINTS_H

#include "chip_std_defs.h"
#include "chip_devtype_spec_features.h"

/* для определения зависимого от настроенного VOS параметра частоты.
 * необходимо определить каждого VOS (N = 0,1,2,3) константы CHIP_CLK_<CLKNAME>_VOS<N>_<PARAM>
 * после чего определить CHIP_CLK_<CLKNAME>_<PARAM> = CHIP_CLK_VOS_PARAM(<CLKNAME>, <PARAM>)
 * в результате чего последняя константа будет соответствовать одной из первых четырех в зависимости от VOS */
#define CHIP_CLK_VOS_PARAM__(clkname, param, vosnum)  (CHIP_CLK_## clkname ## _VOS ## vosnum ## _ ## param)
#define CHIP_CLK_VOS_PARAM_(clkname, param, vosnum)   CHIP_CLK_VOS_PARAM__(clkname, param, vosnum)
#define CHIP_CLK_VOS_PARAM(clkname, param)            CHIP_CLK_VOS_PARAM_(clkname, param, CHIP_CFG_PWR_VOS)

/* граничные условия для внешней частоты HSE */
#define CHIP_CLK_HSE_FREQ_MIN               CHIP_MHZ(4)  /* минимальная внешняя частота HSE */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_HSE_FREQ_MAX               CHIP_MHZ(50) /* максимальная внешняя частота HSE */
#else
#define CHIP_CLK_HSE_FREQ_MAX               CHIP_MHZ(48) /* максимальная внешняя частота HSE */
#endif

/* граничные условия для внешней частоты LSE */
#define CHIP_CLK_LSE_ECLK_FREQ_MAX          CHIP_MHZ(1)     /* максимальня частота LSE в режиме CHIP_CLK_EXTMODE_CLOCK */


#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_CPU_CM7_VOS0_BOOST_FREQ_MAX    CHIP_MHZ(550)
#define CHIP_CLK_CPU_CM7_VOS0_FREQ_MAX          CHIP_MHZ(520)
#define CHIP_CLK_CPU_CM7_VOS1_FREQ_MAX          CHIP_MHZ(400)
#define CHIP_CLK_CPU_CM7_VOS2_FREQ_MAX          CHIP_MHZ(300)
#define CHIP_CLK_CPU_CM7_VOS3_FREQ_MAX          CHIP_MHZ(170)

#define CHIP_CLK_AXI_VOS0_FREQ_MAX              CHIP_MHZ(275)
#define CHIP_CLK_AXI_VOS1_FREQ_MAX              CHIP_MHZ(200)
#define CHIP_CLK_AXI_VOS2_FREQ_MAX              CHIP_MHZ(150)
#define CHIP_CLK_AXI_VOS3_FREQ_MAX              CHIP_MHZ(85)
#else
#define CHIP_CLK_CPU_CM7_VOS0_FREQ_MAX          CHIP_MHZ(480)
#define CHIP_CLK_CPU_CM7_VOS1_FREQ_MAX          CHIP_MHZ(400)
#define CHIP_CLK_CPU_CM7_VOS2_FREQ_MAX          CHIP_MHZ(300)
#define CHIP_CLK_CPU_CM7_VOS3_FREQ_MAX          CHIP_MHZ(200)

#define CHIP_CLK_AXI_VOS0_FREQ_MAX              CHIP_MHZ(240)
#define CHIP_CLK_AXI_VOS1_FREQ_MAX              CHIP_MHZ(200)
#define CHIP_CLK_AXI_VOS2_FREQ_MAX              CHIP_MHZ(150)
#define CHIP_CLK_AXI_VOS3_FREQ_MAX              CHIP_MHZ(100)
#endif

#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST && CHIP_CFG_CLK_CPUFREQ_BOOST && (CHIP_CFG_PWR_VOS == CHIP_PWR_VOS0)
#define CHIP_CLK_CPU_CM7_FREQ_MAX               CHIP_CLK_CPU_CM7_VOS0_BOOST_FREQ_MAX
#else
#define CHIP_CLK_CPU_CM7_FREQ_MAX               CHIP_CLK_VOS_PARAM(CPU_CM7, FREQ_MAX)
#endif

#if CHIP_DEV_SUPPORT_CORE_CM4
#define CHIP_CLK_CPU_CM4_FREQ_MAX               CHIP_CLK_AXI_FREQ_MAX
#endif

#define CHIP_CLK_AXI_FREQ_MAX                   CHIP_CLK_VOS_PARAM(AXI, FREQ_MAX)
#define CHIP_CLK_AHB_FREQ_MAX                   CHIP_CLK_AXI_FREQ_MAX
#define CHIP_CLK_APB_FREQ_MAX                   (CHIP_CLK_AHB_FREQ_MAX/2)



/* пределы входной частоты для PLL */
#define CHIP_CLK_PLL_IN_FREQ_MIN                CHIP_MHZ(1)
#define CHIP_CLK_PLL_IN_FREQ_MAX                CHIP_MHZ(16)
#define CHIP_CLK_PLL_IN_VCOL_FREQ_MAX           CHIP_MHZ(2) /* макс. частота для VCOL (если выше - то VCOH) */

/* пределы выходной частоты для каждого выхода PLL */
#define CHIP_CLK_PLL_VCOH_OUT_FREQ_MIN          CHIP_KHZ(1500)
/* макс. значение зависит от используемого напряжения ядра (VOS) */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_PLL_VCOH_OUT_VOS0_FREQ_MAX     CHIP_MHZ(550)
#define CHIP_CLK_PLL_VCOH_OUT_VOS1_FREQ_MAX     CHIP_MHZ(400)
#define CHIP_CLK_PLL_VCOH_OUT_VOS2_FREQ_MAX     CHIP_MHZ(300)
#define CHIP_CLK_PLL_VCOH_OUT_VOS3_FREQ_MAX     CHIP_MHZ(170)
#else
#define CHIP_CLK_PLL_VCOH_OUT_VOS0_FREQ_MAX     CHIP_MHZ(480)
#define CHIP_CLK_PLL_VCOH_OUT_VOS1_FREQ_MAX     CHIP_MHZ(400)
#define CHIP_CLK_PLL_VCOH_OUT_VOS2_FREQ_MAX     CHIP_MHZ(300)
#define CHIP_CLK_PLL_VCOH_OUT_VOS3_FREQ_MAX     CHIP_MHZ(200)
#endif
#define CHIP_CLK_PLL_VCOH_OUT_FREQ_MAX          CHIP_CLK_VOS_PARAM(PLL_VCOH_OUT, FREQ_MAX)

#define CHIP_CLK_PLL_VCOL_OUT_FREQ_MIN          CHIP_KHZ(1170)
#define CHIP_CLK_PLL_VCOL_OUT_VOS0_FREQ_MAX     CHIP_MHZ(210)
#define CHIP_CLK_PLL_VCOL_OUT_VOS1_FREQ_MAX     CHIP_MHZ(210)
#define CHIP_CLK_PLL_VCOL_OUT_VOS2_FREQ_MAX     CHIP_MHZ(210)
#define CHIP_CLK_PLL_VCOL_OUT_VOS3_FREQ_MAX     CHIP_MHZ(200)
#define CHIP_CLK_PLL_VCOL_OUT_FREQ_MAX          CHIP_CLK_VOS_PARAM(PLL_VCOL_OUT, FREQ_MAX)



#define CHIP_CLK_PLL_DIVM_MIN       1
#define CHIP_CLK_PLL_DIVM_MAX       63
#define CHIP_CLK_PLL_DIVN_MIN       4
#define CHIP_CLK_PLL_DIVN_MAX       512
#define CHIP_CLK_PLL_DIVP_MIN       1
#define CHIP_CLK_PLL_DIVP_MAX       128
#define CHIP_CLK_PLL_DIVQ_MIN       1
#define CHIP_CLK_PLL_DIVQ_MAX       128
#define CHIP_CLK_PLL_DIVR_MIN       1
#define CHIP_CLK_PLL_DIVR_MAX       128
#define CHIP_CLK_PLL_FRACN_MAX      8191


/* пределы промежуточной частоты VCO для двух диапазонов (VCOL, VCOH) */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
    #define CHIP_CLK_PLL_VCOH_FREQ_MAX  CHIP_MHZ(836)
#elif !CHIP_REV_Y_COMPAT_EN
    #define CHIP_CLK_PLL_VCOH_FREQ_MAX  CHIP_MHZ(960)
#else
    #define CHIP_CLK_PLL_VCOH_FREQ_MAX  CHIP_MHZ(836)
#endif
#define CHIP_CLK_PLL_VCOH_FREQ_MIN  CHIP_MHZ(192)
#define CHIP_CLK_PLL_VCOL_FREQ_MAX  CHIP_MHZ(420)
#define CHIP_CLK_PLL_VCOL_FREQ_MIN  CHIP_MHZ(150)


#define CHIP_CLK_RTC_HSE_DIV_MIN   2
#define CHIP_CLK_RTC_HSE_DIV_MAX   63

#define CHIP_CLK_MCO_DIV_MIN       1
#define CHIP_CLK_MCO_DIV_MAX       15





/* максимально допустимые значения kernel-частот (Table 59. Kernel clock distribution overview) */

#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_STD_KER_VOS0_FREQ_MAX              CHIP_MHZ(275)
#define CHIP_CLK_STD_KER_VOS1_FREQ_MAX              CHIP_MHZ(200)
#define CHIP_CLK_STD_KER_VOS2_FREQ_MAX              CHIP_MHZ(150)
#define CHIP_CLK_STD_KER_VOS3_FREQ_MAX              CHIP_MHZ(85)
#else
#define CHIP_CLK_STD_KER_VOS0_FREQ_MAX              CHIP_MHZ(250)
#define CHIP_CLK_STD_KER_VOS1_FREQ_MAX              CHIP_MHZ(200)
#define CHIP_CLK_STD_KER_VOS2_FREQ_MAX              CHIP_MHZ(150)
#define CHIP_CLK_STD_KER_VOS3_FREQ_MAX              CHIP_MHZ(100)
#endif

/* ------------------------------ D1 -----------------------------------------*/
#if CHIP_DEV_SUPPORT_DSI
/* DSI */
#define CHIP_CLK_DSI_KER_VOS0_FREQ_MAX              CHIP_MHZ(133)
#define CHIP_CLK_DSI_KER_VOS1_FREQ_MAX              CHIP_MHZ(133)
#define CHIP_CLK_DSI_KER_VOS2_FREQ_MAX              CHIP_MHZ(100)
#define CHIP_CLK_DSI_KER_VOS3_FREQ_MAX              CHIP_MHZ(66)
#endif

/* LTDC */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_LTDC_KER_VOS0_FREQ_MAX             CHIP_MHZ(166)
#define CHIP_CLK_LTDC_KER_VOS1_FREQ_MAX             CHIP_MHZ(100)
#else
#define CHIP_CLK_LTDC_KER_VOS0_FREQ_MAX             CHIP_MHZ(150)
#define CHIP_CLK_LTDC_KER_VOS1_FREQ_MAX             CHIP_MHZ(150)
#endif
#define CHIP_CLK_LTDC_KER_VOS2_FREQ_MAX             CHIP_MHZ(75)
#define CHIP_CLK_LTDC_KER_VOS3_FREQ_MAX             CHIP_MHZ(50)
#define CHIP_CLK_LTDC_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(LTDC_KER, FREQ_MAX)

/* EXMC / EXMCSEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_EXMC_KER_VOS0_FREQ_MAX             CHIP_MHZ(275)
#define CHIP_CLK_EXMC_KER_VOS1_FREQ_MAX             CHIP_MHZ(200)
#define CHIP_CLK_EXMC_KER_VOS2_FREQ_MAX             CHIP_MHZ(150)
#define CHIP_CLK_EXMC_KER_VOS3_FREQ_MAX             CHIP_MHZ(100)
#else
#define CHIP_CLK_EXMC_KER_VOS0_FREQ_MAX             CHIP_MHZ(300)
#define CHIP_CLK_EXMC_KER_VOS1_FREQ_MAX             CHIP_MHZ(250)
#define CHIP_CLK_EXMC_KER_VOS2_FREQ_MAX             CHIP_MHZ(200)
#define CHIP_CLK_EXMC_KER_VOS3_FREQ_MAX             CHIP_MHZ(133)
#endif
#define CHIP_CLK_EXMC_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(EXMC_KER, FREQ_MAX)

#if CHIP_DEV_SUPPORT_OCTOSPI
/* OCTOSPI */
#define CHIP_CLK_OCTOSPI_KER_VOS0_FREQ_MAX          CHIP_MHZ(333)
#define CHIP_CLK_OCTOSPI_KER_VOS1_FREQ_MAX          CHIP_MHZ(200)
#define CHIP_CLK_OCTOSPI_KER_VOS2_FREQ_MAX          CHIP_MHZ(150)
#define CHIP_CLK_OCTOSPI_KER_VOS3_FREQ_MAX          CHIP_MHZ(100)
#define CHIP_CLK_OCTOSPI_KER_FREQ_MAX               CHIP_CLK_VOS_PARAM(OCTOSPI_KER, FREQ_MAX)
#else
/* QUADSPI / QUADSPISEL */
#define CHIP_CLK_QSPI_KER_VOS0_FREQ_MAX             CHIP_MHZ(250)
#define CHIP_CLK_QSPI_KER_VOS1_FREQ_MAX             CHIP_MHZ(200)
#define CHIP_CLK_QSPI_KER_VOS2_FREQ_MAX             CHIP_MHZ(150)
#define CHIP_CLK_QSPI_KER_VOS3_FREQ_MAX             CHIP_MHZ(100)
#define CHIP_CLK_QSPI_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(QSPI_KER, FREQ_MAX)
#endif

/* SDMMC1, SDMMC2 / SDMMCSEL */
#define CHIP_CLK_SDMMC_KER_VOS0_FREQ_MAX            CHIP_MHZ(250)
#define CHIP_CLK_SDMMC_KER_VOS1_FREQ_MAX            CHIP_MHZ(200)
#define CHIP_CLK_SDMMC_KER_VOS2_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SDMMC_KER_VOS3_FREQ_MAX            CHIP_MHZ(100)
#define CHIP_CLK_SDMMC_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(SDMMC_KER, FREQ_MAX)
/* ------------------------------ D2 (вкл. SDMMC2) ---------------------------*/
/* DFSDM1 Aclk / SAI1SEL */
#define CHIP_CLK_DFSDM1_ACLK_KER_VOS0_FREQ_MAX      CHIP_MHZ(250)
#define CHIP_CLK_DFSDM1_ACLK_KER_VOS1_FREQ_MAX      CHIP_MHZ(200)
#define CHIP_CLK_DFSDM1_ACLK_KER_VOS2_FREQ_MAX      CHIP_MHZ(150)
#define CHIP_CLK_DFSDM1_ACLK_KER_VOS3_FREQ_MAX      CHIP_MHZ(100)
#define CHIP_CLK_DFSDM1_ACLK_KER_FREQ_MAX           CHIP_CLK_VOS_PARAM(DFSDM1_ACLK_KER, FREQ_MAX)

/* DFSDM1 clk / DFSDM1SEL */
#define CHIP_CLK_DFSDM1_KER_VOS0_FREQ_MAX           CHIP_CLK_STD_KER_VOS0_FREQ_MAX
#define CHIP_CLK_DFSDM1_KER_VOS1_FREQ_MAX           CHIP_CLK_STD_KER_VOS1_FREQ_MAX
#define CHIP_CLK_DFSDM1_KER_VOS2_FREQ_MAX           CHIP_CLK_STD_KER_VOS2_FREQ_MAX
#define CHIP_CLK_DFSDM1_KER_VOS3_FREQ_MAX           CHIP_CLK_STD_KER_VOS3_FREQ_MAX
#define CHIP_CLK_DFSDM1_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(DFSDM1_KER, FREQ_MAX)

/* FDCAN / FDCANSEL */
#define CHIP_CLK_FDCAN_KER_VOS0_FREQ_MAX            CHIP_MHZ(125)
#define CHIP_CLK_FDCAN_KER_VOS1_FREQ_MAX            CHIP_MHZ(100)
#define CHIP_CLK_FDCAN_KER_VOS2_FREQ_MAX            CHIP_MHZ(75)
#define CHIP_CLK_FDCAN_KER_VOS3_FREQ_MAX            CHIP_MHZ(50)
#define CHIP_CLK_FDCAN_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(FDCAN_KER, FREQ_MAX)

/* HDMI-CEC /  CECSEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_CEC_KER_VOS0_FREQ_MAX              CHIP_MHZ(1)
#define CHIP_CLK_CEC_KER_VOS1_FREQ_MAX              CHIP_MHZ(1)
#define CHIP_CLK_CEC_KER_VOS2_FREQ_MAX              CHIP_MHZ(1)
#define CHIP_CLK_CEC_KER_VOS3_FREQ_MAX              CHIP_MHZ(1)
#else
#define CHIP_CLK_CEC_KER_VOS0_FREQ_MAX              CHIP_MHZ(66)
#define CHIP_CLK_CEC_KER_VOS1_FREQ_MAX              CHIP_MHZ(66)
#define CHIP_CLK_CEC_KER_VOS2_FREQ_MAX              CHIP_MHZ(66)
#define CHIP_CLK_CEC_KER_VOS3_FREQ_MAX              CHIP_MHZ(33)
#endif
#define CHIP_CLK_CEC_KER_FREQ_MAX                   CHIP_CLK_VOS_PARAM(CEC_KER, FREQ_MAX)

/* I2C1,2,3 (5) / I2C123SEL (I2C1235SEL) */
#define CHIP_CLK_I2C1_2_3_5_KER_VOS0_FREQ_MAX       (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_I2C1_2_3_5_KER_VOS1_FREQ_MAX       (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_I2C1_2_3_5_KER_VOS2_FREQ_MAX       (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_I2C1_2_3_5_KER_VOS3_FREQ_MAX       (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_I2C1_2_3_5_KER_FREQ_MAX            CHIP_CLK_VOS_PARAM(I2C1_2_3_5_KER, FREQ_MAX)

/* LPTIM1 / LPTIM1SEL */
#define CHIP_CLK_LPTIM1_KER_VOS0_FREQ_MAX           (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_LPTIM1_KER_VOS1_FREQ_MAX           (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_LPTIM1_KER_VOS2_FREQ_MAX           (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_LPTIM1_KER_VOS3_FREQ_MAX           (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_LPTIM1_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(LPTIM1_KER, FREQ_MAX)

/* TIM[8:1][17:12][24:23] */
#define CHIP_CLK_TIM_KER_VOS0_FREQ_MAX              CHIP_CLK_STD_KER_VOS0_FREQ_MAX
#define CHIP_CLK_TIM_KER_VOS1_FREQ_MAX              CHIP_CLK_STD_KER_VOS1_FREQ_MAX
#define CHIP_CLK_TIM_KER_VOS2_FREQ_MAX              CHIP_CLK_STD_KER_VOS2_FREQ_MAX
#define CHIP_CLK_TIM_KER_VOS3_FREQ_MAX              CHIP_CLK_STD_KER_VOS3_FREQ_MAX
#define CHIP_CLK_TIM_KER_FREQ_MAX                   CHIP_CLK_VOS_PARAM(TIM_KER, FREQ_MAX)

#if CHIP_DEV_SUPPORT_HRTIM
/* HRTIM */
#define CHIP_CLK_HRTIM_KER_VOS0_FREQ_MAX            CHIP_MHZ(480)
#define CHIP_CLK_HRTIM_KER_VOS1_FREQ_MAX            CHIP_MHZ(400)
#define CHIP_CLK_HRTIM_KER_VOS2_FREQ_MAX            CHIP_MHZ(300)
#define CHIP_CLK_HRTIM_KER_VOS3_FREQ_MAX            CHIP_MHZ(200)
#define CHIP_CLK_HRTIM_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(HRTIM_KER, FREQ_MAX)
#endif

/* RNG / RNGSEL */
#define CHIP_CLK_RNG_KER_VOS0_FREQ_MAX              CHIP_MHZ(250)
#define CHIP_CLK_RNG_KER_VOS1_FREQ_MAX              CHIP_MHZ(200)
#define CHIP_CLK_RNG_KER_VOS2_FREQ_MAX              CHIP_MHZ(150)
#define CHIP_CLK_RNG_KER_VOS3_FREQ_MAX              CHIP_MHZ(100)
#define CHIP_CLK_RNG_KER_FREQ_MAX                   CHIP_CLK_VOS_PARAM(RNG_KER, FREQ_MAX)

/* SAI1 / SAI1SEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SAI1_KER_VOS0_FREQ_MAX             CHIP_MHZ(166)
#else
#define CHIP_CLK_SAI1_KER_VOS0_FREQ_MAX             CHIP_MHZ(150)
#endif
#define CHIP_CLK_SAI1_KER_VOS1_FREQ_MAX             CHIP_MHZ(150)
#define CHIP_CLK_SAI1_KER_VOS2_FREQ_MAX             CHIP_MHZ(113)
#define CHIP_CLK_SAI1_KER_VOS3_FREQ_MAX             CHIP_MHZ(75)
#define CHIP_CLK_SAI1_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(SAI1_KER, FREQ_MAX)

#if CHIP_DEV_SUPPORT_SAI2_3
/* SAI2,3 / SAI23SEL */
#define CHIP_CLK_SAI2_3_KER_VOS0_FREQ_MAX           CHIP_MHZ(150)
#define CHIP_CLK_SAI2_3_KER_VOS1_FREQ_MAX           CHIP_MHZ(150)
#define CHIP_CLK_SAI2_3_KER_VOS2_FREQ_MAX           CHIP_MHZ(133)
#define CHIP_CLK_SAI2_3_KER_VOS3_FREQ_MAX           CHIP_MHZ(75)
#define CHIP_CLK_SAI2_3_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(SAI2_3_KER, FREQ_MAX)
#endif

/* SPDIFRX / SPDIFSEL */
#define CHIP_CLK_SPDIFRX_KER_VOS0_FREQ_MAX          CHIP_MHZ(250)
#define CHIP_CLK_SPDIFRX_KER_VOS1_FREQ_MAX          CHIP_MHZ(200)
#define CHIP_CLK_SPDIFRX_KER_VOS2_FREQ_MAX          CHIP_MHZ(150)
#define CHIP_CLK_SPDIFRX_KER_VOS3_FREQ_MAX          CHIP_MHZ(100)
#define CHIP_CLK_SPDIFRX_KER_FREQ_MAX               CHIP_CLK_VOS_PARAM(SPDIFRX_KER, FREQ_MAX)

/* SPI(I2S)1,2,3 / SPI123SEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SPI1_2_3_KER_VOS0_FREQ_MAX         CHIP_MHZ(250)
#define CHIP_CLK_SPI1_2_3_KER_VOS1_FREQ_MAX         CHIP_MHZ(180)
#define CHIP_CLK_SPI1_2_3_KER_VOS2_FREQ_MAX         CHIP_MHZ(125)
#define CHIP_CLK_SPI1_2_3_KER_VOS3_FREQ_MAX         CHIP_MHZ(75)
#else
#define CHIP_CLK_SPI1_2_3_KER_VOS0_FREQ_MAX         CHIP_MHZ(200)
#define CHIP_CLK_SPI1_2_3_KER_VOS1_FREQ_MAX         CHIP_MHZ(200)
#define CHIP_CLK_SPI1_2_3_KER_VOS2_FREQ_MAX         CHIP_MHZ(150)
#define CHIP_CLK_SPI1_2_3_KER_VOS3_FREQ_MAX         CHIP_MHZ(100)
#endif
#define CHIP_CLK_SPI1_2_3_KER_FREQ_MAX              CHIP_CLK_VOS_PARAM(SPI1_2_3_KER, FREQ_MAX)

/* SPI4,5 /  SPI45SEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SPI4_5_KER_VOS0_FREQ_MAX           CHIP_MHZ(250)
#define CHIP_CLK_SPI4_5_KER_VOS1_FREQ_MAX           CHIP_MHZ(180)
#define CHIP_CLK_SPI4_5_KER_VOS2_FREQ_MAX           CHIP_MHZ(125)
#define CHIP_CLK_SPI4_5_KER_VOS3_FREQ_MAX           CHIP_MHZ(75)
#else
#define CHIP_CLK_SPI4_5_KER_VOS0_FREQ_MAX           (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_SPI4_5_KER_VOS1_FREQ_MAX           (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_SPI4_5_KER_VOS2_FREQ_MAX           (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_SPI4_5_KER_VOS3_FREQ_MAX           (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#endif
#define CHIP_CLK_SPI4_5_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(SPI4_5_KER, FREQ_MAX)

/* SWPMI /  SWPSEL */
#define CHIP_CLK_SWPMI_KER_VOS0_FREQ_MAX            (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_SWPMI_KER_VOS1_FREQ_MAX            (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_SWPMI_KER_VOS2_FREQ_MAX            (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_SWPMI_KER_VOS3_FREQ_MAX            (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_SWPMI_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(SWPMI_KER, FREQ_MAX)

/* USART1,6 (10, UART9) / USART16SEL */
#define CHIP_CLK_USART1_6_9_10_KER_VOS0_FREQ_MAX    (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_USART1_6_9_10_KER_VOS1_FREQ_MAX    (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_USART1_6_9_10_KER_VOS2_FREQ_MAX    (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_USART1_6_9_10_KER_VOS3_FREQ_MAX    (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_USART1_6_9_10_KER_FREQ_MAX         CHIP_CLK_VOS_PARAM(USART1_6_9_10_KER, FREQ_MAX)

/* USART2,3, UART4,5,7,8 / USART234578SEL */
#define CHIP_CLK_USART2_3_4_5_7_8_KER_VOS0_FREQ_MAX (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_USART2_3_4_5_7_8_KER_VOS1_FREQ_MAX (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_USART2_3_4_5_7_8_KER_VOS2_FREQ_MAX (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_USART2_3_4_5_7_8_KER_VOS3_FREQ_MAX (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_USART2_3_4_5_7_8_KER_FREQ_MAX      CHIP_CLK_VOS_PARAM(USART2_3_4_5_7_8_KER, FREQ_MAX)

/* USB1OTG, USB2OTG / USBSEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_USBOTG_KER_VOS0_FREQ_MAX           CHIP_MHZ(125)
#define CHIP_CLK_USBOTG_KER_VOS1_FREQ_MAX           CHIP_MHZ(100)
#define CHIP_CLK_USBOTG_KER_VOS2_FREQ_MAX           CHIP_MHZ(50)
#define CHIP_CLK_USBOTG_KER_VOS3_FREQ_MAX           CHIP_MHZ(50)
#else
#define CHIP_CLK_USBOTG_KER_VOS0_FREQ_MAX           CHIP_MHZ(66)
#define CHIP_CLK_USBOTG_KER_VOS1_FREQ_MAX           CHIP_MHZ(66)
#define CHIP_CLK_USBOTG_KER_VOS2_FREQ_MAX           CHIP_MHZ(66)
#define CHIP_CLK_USBOTG_KER_VOS3_FREQ_MAX           CHIP_MHZ(63)
#endif
#define CHIP_CLK_USBOTG_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(USBOTG_KER, FREQ_MAX)

/* USB1ULPI */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_USBULPI_KER_VOS0_FREQ_MAX          CHIP_MHZ(60)
#define CHIP_CLK_USBULPI_KER_VOS1_FREQ_MAX          CHIP_MHZ(60)
#define CHIP_CLK_USBULPI_KER_VOS2_FREQ_MAX          CHIP_MHZ(45)
#define CHIP_CLK_USBULPI_KER_VOS3_FREQ_MAX          CHIP_MHZ(40)
#else
#define CHIP_CLK_USBULPI_KER_VOS0_FREQ_MAX          CHIP_MHZ(60)
#define CHIP_CLK_USBULPI_KER_VOS1_FREQ_MAX          CHIP_MHZ(60)
#define CHIP_CLK_USBULPI_KER_VOS2_FREQ_MAX          CHIP_MHZ(60)
#define CHIP_CLK_USBULPI_KER_VOS3_FREQ_MAX          CHIP_MHZ(60)
#endif
#define CHIP_CLK_USBULPI_KER_FREQ_MAX               CHIP_CLK_VOS_PARAM(USBULPI_KER, FREQ_MAX)

/* ADC1,2,3 / ADCSEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_ADC_KER_VOS0_FREQ_MAX              CHIP_MHZ(160)
#define CHIP_CLK_ADC_KER_VOS1_FREQ_MAX              CHIP_MHZ(160)
#define CHIP_CLK_ADC_KER_VOS2_FREQ_MAX              CHIP_MHZ(60)
#define CHIP_CLK_ADC_KER_VOS3_FREQ_MAX              CHIP_MHZ(40)
#else
#define CHIP_CLK_ADC_KER_VOS0_FREQ_MAX              CHIP_MHZ(80)
#define CHIP_CLK_ADC_KER_VOS1_FREQ_MAX              CHIP_MHZ(80)
#define CHIP_CLK_ADC_KER_VOS2_FREQ_MAX              CHIP_MHZ(40)
#define CHIP_CLK_ADC_KER_VOS3_FREQ_MAX              CHIP_MHZ(40)
#endif
#define CHIP_CLK_ADC_KER_FREQ_MAX                   CHIP_CLK_VOS_PARAM(ADC_KER, FREQ_MAX)\

/* ------------------------------ D3 -----------------------------------------*/
/* I2C4 / I2C4SEL */
#define CHIP_CLK_I2C4_KER_VOS0_FREQ_MAX             (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_I2C4_KER_VOS1_FREQ_MAX             (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_I2C4_KER_VOS2_FREQ_MAX             (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_I2C4_KER_VOS3_FREQ_MAX             (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_I2C4_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(I2C4, FREQ_MAX)

/* LPTIM2 / LPTIM2SEL */
#define CHIP_CLK_LPTIM2_KER_VOS0_FREQ_MAX           (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_LPTIM2_KER_VOS1_FREQ_MAX           (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_LPTIM2_KER_VOS2_FREQ_MAX           (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_LPTIM2_KER_VOS3_FREQ_MAX           (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_LPTIM2_KER_FREQ_MAX                CHIP_CLK_VOS_PARAM(LPTIM2_KER, FREQ_MAX)

/* LPTIM3,4,5 / LPTIM345SEL */
#define CHIP_CLK_LPTIM3_4_5_KER_VOS0_FREQ_MAX       (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_LPTIM3_4_5_KER_VOS1_FREQ_MAX       (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_LPTIM3_4_5_KER_VOS2_FREQ_MAX       (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_LPTIM3_4_5_KER_VOS3_FREQ_MAX       (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_LPTIM3_4_5_KER_FREQ_MAX            CHIP_CLK_VOS_PARAM(LPTIM3_4_5_KER, FREQ_MAX)

/* LPUART1 / LPUART1SEL */
#define CHIP_CLK_LPUART1_KER_VOS0_FREQ_MAX          (CHIP_CLK_STD_KER_VOS0_FREQ_MAX/2)
#define CHIP_CLK_LPUART1_KER_VOS1_FREQ_MAX          (CHIP_CLK_STD_KER_VOS1_FREQ_MAX/2)
#define CHIP_CLK_LPUART1_KER_VOS2_FREQ_MAX          (CHIP_CLK_STD_KER_VOS2_FREQ_MAX/2)
#define CHIP_CLK_LPUART1_KER_VOS3_FREQ_MAX          (CHIP_CLK_STD_KER_VOS3_FREQ_MAX/2)
#define CHIP_CLK_LPUART1_KER_FREQ_MAX               CHIP_CLK_VOS_PARAM(LPUART1_KER, FREQ_MAX)

/* SAI4_A / SAI4ASEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SAI4A_KER_VOS0_FREQ_MAX            CHIP_MHZ(166)
#define CHIP_CLK_SAI4A_KER_VOS1_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4A_KER_VOS2_FREQ_MAX            CHIP_MHZ(113)
#define CHIP_CLK_SAI4A_KER_VOS3_FREQ_MAX            CHIP_MHZ(75)
#else
#define CHIP_CLK_SAI4A_KER_VOS0_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4A_KER_VOS1_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4A_KER_VOS2_FREQ_MAX            CHIP_MHZ(75)
#define CHIP_CLK_SAI4A_KER_VOS3_FREQ_MAX            CHIP_MHZ(75)
#endif
#define CHIP_CLK_SAI4A_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(SAI4A_KER, FREQ_MAX)

/* SAI4_B / SAI4BSEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SAI4B_KER_VOS0_FREQ_MAX            CHIP_MHZ(166)
#define CHIP_CLK_SAI4B_KER_VOS1_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4B_KER_VOS2_FREQ_MAX            CHIP_MHZ(113)
#define CHIP_CLK_SAI4B_KER_VOS3_FREQ_MAX            CHIP_MHZ(75)
#else
#define CHIP_CLK_SAI4B_KER_VOS0_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4B_KER_VOS1_FREQ_MAX            CHIP_MHZ(150)
#define CHIP_CLK_SAI4B_KER_VOS2_FREQ_MAX            CHIP_MHZ(75)
#define CHIP_CLK_SAI4B_KER_VOS3_FREQ_MAX            CHIP_MHZ(75)
#endif
#define CHIP_CLK_SAI4B_KER_FREQ_MAX                 CHIP_CLK_VOS_PARAM(SAI4B_KER, FREQ_MAX)

/* SPI6 /  SPI6SEL */
#if CHIP_DEV_SUPPORT_CPUFREQ_BOOST
#define CHIP_CLK_SPI6_KER_VOS0_FREQ_MAX             CHIP_MHZ(250)
#define CHIP_CLK_SPI6_KER_VOS1_FREQ_MAX             CHIP_MHZ(180)
#define CHIP_CLK_SPI6_KER_VOS2_FREQ_MAX             CHIP_MHZ(125)
#define CHIP_CLK_SPI6_KER_VOS3_FREQ_MAX             CHIP_MHZ(75)
#else
#define CHIP_CLK_SPI6_KER_VOS0_FREQ_MAX             CHIP_MHZ(125)
#define CHIP_CLK_SPI6_KER_VOS1_FREQ_MAX             CHIP_MHZ(100)
#define CHIP_CLK_SPI6_KER_VOS2_FREQ_MAX             CHIP_MHZ(75)
#define CHIP_CLK_SPI6_KER_VOS3_FREQ_MAX             CHIP_MHZ(50)
#endif
#define CHIP_CLK_SPI6_KER_FREQ_MAX                  CHIP_CLK_VOS_PARAM(SPI6_KER, FREQ_MAX)

/* RTC/AWU / RTCSEL */
#define CHIP_CLK_RTC_FREQ_MAX                       CHIP_MHZ(1)

#endif // CHIP_CLK_CONSTRAINTS_H


